from dune.perftool.generation import (backend,
                                      domain)


@backend(interface="lfs_inames", name="blockstructured")
def lfs_inames(element, restriction, count=None, context=''):
    assert not ((context == '') and (count is None))
    if count is not None:
        if context != '':
            context = "{}_{}".format(count, context)
        else:
            context = str(count)

    name = "micro_{}_index".format(context)
    domain(name, 4)

    return name,
